# distutils: language = c++
from libcpp.string cimport string
from libcpp cimport bool
from util cimport istream

cdef extern from "<fst/symbol-table.h>" namespace "fst":    
    cdef cppclass SymbolTable:
        SymbolTable(SymbolTable &table)
        SymbolTable(string &name)
        long AddSymbol(string &symbol, long key)
        long AddSymbol(string &symbol)
        string& Name()
        bint Write(string &filename)
        bint WriteText (string &filename)
        string Find(long key)
        long Find(const char* symbol)
        unsigned NumSymbols()
        string LabeledCheckSum()

    cdef cppclass SymbolTableIterator:
        SymbolTableIterator(SymbolTable& table)
        bint Done()
        long Value()
        string Symbol()
        void Next()
        void Reset()

    cdef SymbolTable* SymbolTableRead "fst::SymbolTable::Read" (istream &strm,
            string& source)

    cdef SymbolTable* SymbolTableReadText "fst::SymbolTable::ReadText" (
            istream &strm, string& source)
